<?php 
/**
* Plugin Name: Update User Meta Request
* Plugin URI: 
* Description: Request Faculy and Email if email == to the email prefix in the CAS plugin. 
* Author: CTLT DEV,scott_mcmillan, enejb
* Version: 0.1.1
* Author URI: http://github.com/ubc/
*/

/**
 * CTLT_Update_User_Info_Notice class.
 */
class CTLT_Update_User_Info_Notice {
		
	/**
	 * start function.
	 * 
	 * @access public
	 * @return void
	 */
	public static function start() {

		if ( is_admin() ) {
			$user_ID = get_current_user_id();		
			$cas_email_suffix = self::check_cas_email_prefix();
	      		$email_check = self::check_valid_email( $cas_email_suffix ); 
	
        		// Check if user has entered a UBC role.
        		$key = 'facultyUBC';
        		$faculty_role_check = get_user_meta( $user_ID, $key );

			if( $email_check == false  || !isset( $faculty_role_check ) ) {
				add_action( 'all_admin_notices', array(__CLASS__, 'show') );
			}
		} 
	}
	
	/**
	 * show function.
	 * 
	 * @access public
	 * @return void
	 */
	public function show() {
		
		$user_ID = get_current_user_id();		
		$faculties = self::ctlt_get_ubc_faculties();
	
		if ( !isset( $_POST['faculty'] ) ) {
			$faculty_id =  get_user_meta( $user_ID, 'facultyUBC', true );
		} else {
			$faculty_id = "";
		}

		$cas_email_suffix = self::check_cas_email_prefix();

		// Check if email has been submited and valid 
		if ( isset( $_POST['updated_email'] ) ) {
		
			// Check if email is valid first
			if ( !is_email( $_POST['updated_email'] ) ) {
				 $email_check_fail = true; 
			} 	
				
			if ( isset($cas_email_suffix) ) { 
				$email_domain_check = explode( '@', $_POST['updated_email'] );
			}
			
			if(empty( $email_domain_check[1] ) ) {
				$email_check_fail = true; 
			} elseif ( $email_domain_check[1] == $cas_email_suffix ) {
				$email_check_fail = true;			
			}	
			
			$email_exists = email_exists( $_POST['updated_email'] );
				
			if ( $email_exists ) {
				if( $email_exists !=  $user_ID ) {
				  		$email_exists = true;
				}
			}	
		}

		// Check if email has been submited and valid 
                if ( isset( $_POST['faculty'] ) && empty( $_POST['faculty'] ) ) {
			$faculty_check_fail = true;
		}
		
	$faculty_role_check = get_user_meta( $user_ID, $key );	

	if ( $_POST['update_user_info_nonce'] && wp_verify_nonce( $_POST['update_user_info_nonce'], 'update_user_info' ) && isset( $_POST['updated_email'] ) && $email_check_fail != true && $email_exists != true && $faculty_check_fail != true ) {	
			
			$updated_email = $_POST['updated_email'];	
			$updated_email = esc_html( $updated_email );
			
			$updated_faculty = $_POST['faculty'];
                        $updated_faculty = esc_html( $updated_faculty );

			$updated_ID = wp_update_user( array ( 'ID' => $user_ID, 'user_email' => $updated_email ) );	
			$updated_facultyID = update_user_meta( $user_ID, 'facultyUBC', $updated_faculty  );
		
			?>
			
		<div class="updated" id="message"><p>Thanks for updating your user info. To update your email in the future please visit <a href="<?php echo admin_url('profile.php'); ?>">Profile Settings</a></strong></p></div>
		
		<script type="text/javascript">
                jQuery(document).ready(function($){
    			var newEmail = "<?php echo"$updated_email";?>";	
			$("#email").val(newEmail); 
		});
		</script>

		<?php
		} else { 
		
                        $update_user_info_nonce = $_POST['update_user_info_nonce'];
                        
			$faculty_id = (	in_array( $_POST['faculty'], array_keys ($faculties) ) ? $_POST['faculty'] : $faculty_id ) ;

                        $updated_email = $_POST['updated_email'];

			$email_exists = email_exists($updated_email);

			$updated_faculty = $_POST['faculty'];

			if ( $email_check_fail == true || $email_exists != false || isset( $_POST['faculty'] ) ) { 
			?>                        
				<div id="message" class="error below-h2">
				<?php
				if ( $email_check_fail == true ) {
					echo"<p><strong>ERROR</strong>: Email is not valid.</p>";
				}
				
				if ( $email_exists != false  && $email_exists != $user_ID ) {
					echo"<p><strong>ERROR</strong>: The email address is already being used.</p>"; 
				}

				if ( isset( $_POST['faculty'] ) && empty( $updated_faculty ) ) {
					echo"<p><strong>ERROR</strong>: Faculty or Unit not set.</p>";
				}
				?>
				</div>
			<?php
			}
			?>
		
			<div style="position:absolute; width:100%; background:#FFF; height:100%; z-index:100;"></div>
			<div class="welcome-panel" style="margin-right:20px; clear:both; padding:50px 20px; z-index:101;">
			<div class="welcome-panel-content">
			<h3>We need a little more info for your account. </h3>
			<p class="about-description">In order for us to provide a better service we ask please fill out the information below. </p>
			<form action="" method="post">
				<div style="float:left;margin-right:10px;">
                                                <label>Email</label><br />
                                     		<input class="input-primary" type="text" name="updated_email" value="<?php if( isset( $_POST['updated_email'] ) ){ echo"$updated_email"; } ?>" />
				 </div>
				 <div style="float:left;margin-right:10px;">
					<label>Faculty or Unit</label><br />
						<select name="faculty">
							<option value="">Select</option>
							<?php 
							asort( $faculties );
							foreach( $faculties as $faculty_key => $faculty_value ) { 
							?>
							<option value="<?php echo"$faculty_key"; ?>" <?php selected( $_POST['faculty'], $faculty_key ); ?>> <?php echo"$faculty_value"; ?></option>
							<?php } ?>
						</select>
				  </div>
				  <div>
				  <br />
				  <input class="button-primary" type="submit" name="update-site-notice" value="<?php _e( 'Update' ); ?>" />
				  </div>
				<?php wp_nonce_field( 'update_user_info','update_user_info_nonce' ); ?>
			</form>
				<p>Note: This message will be gone after you fill in this information. However you will always be able to update again when you go to <strong><a href="<?php echo admin_url('profile.php'); ?>">Profile Settings</a></strong></p>
			</div>
			</div>
			<?php
		}
	}

	/**
 	 * ctlt_get_ubc_faculties function.
 	 * 
 	 * @access public
 	 * @return array
 	*/
	public function ctlt_get_ubc_faculties() {
		if ( file_exists( WP_CONTENT_DIR.'/UserInfo.ini' ) ) {
                	$init_file = parse_ini_file ( WP_CONTENT_DIR.'/UserInfo.ini', true );
                } else {
                	$init_file = parse_ini_file ( dirname(__FILE__).'/UserInfo.ini', true );
               	}
                return $init_file['faculty'];
	}
	
	 /**
         * check_cas_email_prefix function.
         * 
         * @access public
         * @return string
        */
	private function check_cas_email_prefix() {	
		// Compare the  email domain to the setting in the CAS_options. 
                $cas_authentication_opt = get_site_option( 'cas_authentication_options' );
                $cas_email_suffix = $cas_authentication_opt['email_suffix'];
	
		if ( !empty( $cas_email_suffix ) ) {
			return $cas_email_suffix;
		}
	}

	 /**
         * check_valid_email function.
	 *
         * Check if it's valid and if it is the same as the cas_email_prefix option fail
	 * 
         * @access private
	 * @param string email suffix from cas site option 
	 * @PARAM string posted submitted email
         * @return bool
        */
	
	private function check_valid_email( $cas_email_suffix ) {
	        
		$user_ID = get_current_user_id(); 
                $user_info = get_userdata( $user_ID );

		if ( isset( $cas_email_suffix ) ) {  
                	// Nake sure the user has n email and is not set to the default CAS email_prefix. 
                	if ( !empty( $user_info->user_email ) ) {
                        	$email_domain = explode( '@', $user_info->user_email );
                	}
				
                	if( !is_email( $user_info->user_email ) || $cas_email_suffix == $email_domain[1]  ) {
                		return false;
			} else {
				return true;
			}
		}	
	}	

}
add_action( 'init', array( 'CTLT_Update_User_Info_Notice', 'start' ) );
